/****************************************************************************
 * This file is part of the project AqHome.
 * AqHome (c) by 2023 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <aqhome/ipc/nodes/msg_ipc_getdevices_rsp.h>

#include <gwenhywfar/msg.h>
#include <gwenhywfar/buffer.h>

#include <gwenhywfar/misc.h>
#include <gwenhywfar/list.h>
#include <gwenhywfar/error.h>
#include <gwenhywfar/debug.h>
#include <gwenhywfar/text.h>
#include <gwenhywfar/msg_ipc.h>


#define AQH_MSGIPC_GETDEVICES_RSP_OFFS_FLAGS        0   /* 1 bytes */
#define AQH_MSGIPC_GETDEVICES_RSP_OFFS_BUSADDR      1   /* 1 bytes */
#define AQH_MSGIPC_GETDEVICES_RSP_OFFS_UID          2   /* 4 bytes */
#define AQH_MSGIPC_GETDEVICES_RSP_OFFS_FWTYPE       6   /* 2 bytes */
#define AQH_MSGIPC_GETDEVICES_RSP_OFFS_FWVER        8   /* 2 bytes */
#define AQH_MSGIPC_GETDEVICES_RSP_OFFS_MODULES     10   /* 2 bytes */
#define AQH_MSGIPC_GETDEVICES_RSP_OFFS_LASTCHG     12   /* 8 bytes */
#define AQH_MSGIPC_GETDEVICES_RSP_OFFS_PKGOUT      20   /* 2 bytes */
#define AQH_MSGIPC_GETDEVICES_RSP_OFFS_PKGIN       22   /* 2 bytes */
#define AQH_MSGIPC_GETDEVICES_RSP_OFFS_COLLISIONS  24   /* 2 bytes */
#define AQH_MSGIPC_GETDEVICES_RSP_OFFS_BUSY        26   /* 2 bytes */
#define AQH_MSGIPC_GETDEVICES_RSP_OFFS_CRC         28   /* 2 bytes */
#define AQH_MSGIPC_GETDEVICES_RSP_OFFS_IO          30   /* 2 bytes */


#define AQH_MSGIPC_GETDEVICES_RSP_MINSIZE          (GWEN_MSGIPC_OFFS_PAYLOAD+AQH_MSGIPC_GETDEVICES_RSP_OFFS_LASTCHG+8)




GWEN_MSG *AQH_GetDevicesResponseIpcMsg_new(uint16_t code, uint8_t flags, const AQH_NODE_INFO *ni)
{
  GWEN_MSG *msg;
  uint8_t *ptr;
  uint32_t u32;
  uint64_t u64=0;
  const GWEN_TIMESTAMP *t;

  msg=GWEN_IpcMsg_new(AQH_IPC_PROTOCOL_NODES_ID, AQH_IPC_PROTOCOL_NODES_VERSION, code, AQH_MSGIPC_GETDEVICES_RSP_MINSIZE, NULL);
  ptr=GWEN_Msg_GetBuffer(msg)+GWEN_MSGIPC_OFFS_PAYLOAD;

  *(ptr++)=flags & 0xff;

  *(ptr++)=AQH_NodeInfo_GetBusAddress(ni);

  u32=AQH_NodeInfo_GetUid(ni);
  *(ptr++)=u32 & 0xff;
  *(ptr++)=(u32>>8) & 0xff;
  *(ptr++)=(u32>>16) & 0xff;
  *(ptr++)=(u32>>24) & 0xff;

  u32=AQH_NodeInfo_GetFirmwareType(ni);
  *(ptr++)=u32 & 0xff;
  *(ptr++)=(u32>>8) & 0xff;

  u32=AQH_NodeInfo_GetFirmwareVersion(ni);
  *(ptr++)=u32 & 0xff;
  *(ptr++)=(u32>>8) & 0xff;

  u32=AQH_NodeInfo_GetModules(ni);
  *(ptr++)=u32 & 0xff;
  *(ptr++)=(u32>>8) & 0xff;

  t=AQH_NodeInfo_GetTimestampLastChange(ni);
  if (t)
    u64=(uint64_t)GWEN_Timestamp_toInt64(t);
  *(ptr++)=u64 & 0xff;
  *(ptr++)=(u64>>8) & 0xff;
  *(ptr++)=(u64>>16) & 0xff;
  *(ptr++)=(u64>>24) & 0xff;
  *(ptr++)=(u64>>32) & 0xff;
  *(ptr++)=(u64>>40) & 0xff;
  *(ptr++)=(u64>>48) & 0xff;
  *(ptr++)=(u64>>56) & 0xff;

  u32=AQH_NodeInfo_GetStatsPacketsOut(ni);
  *(ptr++)=u32 & 0xff;
  *(ptr++)=(u32>>8) & 0xff;

  u32=AQH_NodeInfo_GetStatsPacketsIn(ni);
  *(ptr++)=u32 & 0xff;
  *(ptr++)=(u32>>8) & 0xff;

  u32=AQH_NodeInfo_GetStatsCollisions(ni);
  *(ptr++)=u32 & 0xff;
  *(ptr++)=(u32>>8) & 0xff;

  u32=AQH_NodeInfo_GetStatsBusy(ni);
  *(ptr++)=u32 & 0xff;
  *(ptr++)=(u32>>8) & 0xff;

  u32=AQH_NodeInfo_GetStatsCrcErrors(ni);
  *(ptr++)=u32 & 0xff;
  *(ptr++)=(u32>>8) & 0xff;

  u32=AQH_NodeInfo_GetStatsIoErrors(ni);
  *(ptr++)=u32 & 0xff;
  *(ptr++)=(u32>>8) & 0xff;

  return msg;
}



uint8_t AQH_GetDevicesResponseIpcMsg_GetFlags(const GWEN_MSG *msg)
{
  return GWEN_Msg_GetUint8At(msg, GWEN_MSGIPC_OFFS_PAYLOAD+AQH_MSGIPC_GETDEVICES_RSP_OFFS_FLAGS, 0);
}



uint8_t AQH_GetDevicesResponseIpcMsg_GetBusAddress(const GWEN_MSG *msg)
{
  return GWEN_Msg_GetUint16At(msg, GWEN_MSGIPC_OFFS_PAYLOAD+AQH_MSGIPC_GETDEVICES_RSP_OFFS_BUSADDR, 0);
}



uint32_t AQH_GetDevicesResponseIpcMsg_GetUid(const GWEN_MSG *msg)
{
  return GWEN_Msg_GetUint32At(msg, GWEN_MSGIPC_OFFS_PAYLOAD+AQH_MSGIPC_GETDEVICES_RSP_OFFS_UID, 0);
}



uint16_t AQH_GetDevicesResponseIpcMsg_GetFirmwareType(const GWEN_MSG *msg)
{
  return GWEN_Msg_GetUint16At(msg, GWEN_MSGIPC_OFFS_PAYLOAD+AQH_MSGIPC_GETDEVICES_RSP_OFFS_FWTYPE, 0);
}



uint16_t AQH_GetDevicesResponseIpcMsg_GetFirmwareVersion(const GWEN_MSG *msg)
{
  return GWEN_Msg_GetUint16At(msg, GWEN_MSGIPC_OFFS_PAYLOAD+AQH_MSGIPC_GETDEVICES_RSP_OFFS_FWVER, 0);
}



uint16_t AQH_GetDevicesResponseIpcMsg_GetModules(const GWEN_MSG *msg)
{
  return GWEN_Msg_GetUint16At(msg, GWEN_MSGIPC_OFFS_PAYLOAD+AQH_MSGIPC_GETDEVICES_RSP_OFFS_MODULES, 0);
}



int64_t AQH_GetDevicesResponseIpcMsg_GetTimestamp(const GWEN_MSG *msg)
{
  uint64_t v;

  v=(uint64_t) GWEN_Msg_GetUint32At(msg, GWEN_MSGIPC_OFFS_PAYLOAD+AQH_MSGIPC_GETDEVICES_RSP_OFFS_LASTCHG, 0);
  v|=((uint64_t)GWEN_Msg_GetUint32At(msg, GWEN_MSGIPC_OFFS_PAYLOAD+AQH_MSGIPC_GETDEVICES_RSP_OFFS_LASTCHG+4, 0))<<32;
  return (int64_t) v;
}



uint16_t AQH_GetDevicesResponseIpcMsg_GetPkgOut(const GWEN_MSG *msg)
{
  return GWEN_Msg_GetUint16At(msg, GWEN_MSGIPC_OFFS_PAYLOAD+AQH_MSGIPC_GETDEVICES_RSP_OFFS_PKGOUT, 0);
}



uint16_t AQH_GetDevicesResponseIpcMsg_GetPkgIn(const GWEN_MSG *msg)
{
  return GWEN_Msg_GetUint16At(msg, GWEN_MSGIPC_OFFS_PAYLOAD+AQH_MSGIPC_GETDEVICES_RSP_OFFS_PKGIN, 0);
}



uint16_t AQH_GetDevicesResponseIpcMsg_GetCollisions(const GWEN_MSG *msg)
{
  return GWEN_Msg_GetUint16At(msg, GWEN_MSGIPC_OFFS_PAYLOAD+AQH_MSGIPC_GETDEVICES_RSP_OFFS_COLLISIONS, 0);
}



uint16_t AQH_GetDevicesResponseIpcMsg_GetBusy(const GWEN_MSG *msg)
{
  return GWEN_Msg_GetUint16At(msg, GWEN_MSGIPC_OFFS_PAYLOAD+AQH_MSGIPC_GETDEVICES_RSP_OFFS_BUSY, 0);
}



uint16_t AQH_GetDevicesResponseIpcMsg_GetCrcErrors(const GWEN_MSG *msg)
{
  return GWEN_Msg_GetUint16At(msg, GWEN_MSGIPC_OFFS_PAYLOAD+AQH_MSGIPC_GETDEVICES_RSP_OFFS_CRC, 0);
}



uint16_t AQH_GetDevicesResponseIpcMsg_GetIoErrors(const GWEN_MSG *msg)
{
  return GWEN_Msg_GetUint16At(msg, GWEN_MSGIPC_OFFS_PAYLOAD+AQH_MSGIPC_GETDEVICES_RSP_OFFS_IO, 0);
}



void AQH_GetDevicesResponseIpcMsg_DumpToBuffer(const GWEN_MSG *msg, GWEN_BUFFER *dbuf, const char *sText)
{
  if (GWEN_Msg_GetBytesInBuffer(msg)>=AQH_MSGIPC_GETDEVICES_RSP_MINSIZE) {
    GWEN_Buffer_AppendArgs(dbuf,
                           "GET_DEVICES_RSP (code=%d, proto=%d, proto version=%d, uid=0x%08x, bus addr=0x%02x, flags=0x%02x)\n",
                           GWEN_IpcMsg_GetCode(msg),
                           GWEN_IpcMsg_GetProtoId(msg),
                           GWEN_IpcMsg_GetProtoVersion(msg),
                           (unsigned int) AQH_GetDevicesResponseIpcMsg_GetUid(msg),
                           AQH_GetDevicesResponseIpcMsg_GetBusAddress(msg),
                           AQH_GetDevicesResponseIpcMsg_GetFlags(msg));
  }
}







